
;CodeVisionAVR C Compiler V1.25.3 Standard
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 512 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test.vec"
	.INCLUDE "test.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x260
;       1 // ============================= Atmega16 CPU ׽Ʈ α׷ =================
;       2 //  CPU : ATmega16-16M
;       3 //     ¥ : 2006-
;       4 //      : Ver1.0
;       5 //    : www.cpuplaza.com
;       6 // Ϸ : CodeVisionAVR
;       7 //      : serial 19200,N,8,1
;       8 // ----------------------------------------------------------------------------
;       9 // ⺻ 
;      10 #include <mega16.h>						// CPU  
;      11 
;      12 #include <stdio.h>
;      13 #include <stdlib.h>
;      14 #include <ctype.h>
;      15 #include <float.h>
;      16 
;      17 //  
;      18 #include "cpusetup.inc"						// cpu  ͷƮ  ƾ
;      19 // =================================== CPUʱȭ ͷƮ ===================
;      20 //      : CPU  ϰ ͷƮ  ƾ .
;      21 // ----------------------------------------------------------------------------
;      22 //   
;      23 #define RXB8 1
;      24 #define TXB8 0
;      25 #define UPE 2
;      26 #define OVR 3
;      27 #define FE 4
;      28 #define UDRE 5
;      29 #define RXC 7
;      30 
;      31 #define FRAMING_ERROR (1<<FE)
;      32 #define PARITY_ERROR (1<<UPE)
;      33 #define DATA_OVERRUN (1<<OVR)
;      34 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      35 #define RX_COMPLETE (1<<RXC)
;      36 
;      37 //  
;      38 char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷
;      39 
;      40 int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
;      41 int timer1_cnt = 0;						// Ÿ̸1 ͷƮ  ī
;      42 int timer2_cnt = 0;						// Ÿ̸2 ͷƮ  ī
;      43 
;      44 int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
;      45 int exint1_flg = 0;						// EXINT1 ͷƮ  ÷
_exint1_flg:
	.BYTE 0x2
;      46 int exint2_flg = 0;						// EXINT2 ͷƮ  ÷
_exint2_flg:
	.BYTE 0x2
;      47 
;      48 unsigned int adc_int_data = 0;					// ADC ͷƮ  
_adc_int_data:
	.BYTE 0x2
;      49 int adc_int_ch = 0;						// ADC CH ͷƮ 
_adc_int_ch:
	.BYTE 0x2
;      50 int adc_int_flg = 0;						// ADC ͷƮ  ÷
_adc_int_flg:
	.BYTE 0x2
;      51 
;      52 // ===================================== CPUʱȭ ============================
;      53 // [μ] void
;      54 // ----------------------------------------------------------------------------
;      55 void cpu_setup(void)
;      56 {

	.CSEG
_cpu_setup:
;      57 
;      58 // PortA 
;      59 	PORTA=0x00;						// Ʈ  reg
	CALL SUBOPT_0x0
;      60 	DDRA=0x00;						// Ʈ  reg(0Է,1)
;      61 // PortB 
;      62 	PORTB=0x00;						// Ʈ  reg
;      63 	DDRB=0x00;						// Ʈ  reg(0Է,1)
;      64 
;      65 // PortC 
;      66 	PORTC=0x00;						// Ʈ  reg
;      67 	DDRC=0x00;                                              // Ʈ  reg(0Է,1)
;      68 
;      69 // PortD 
;      70 	PORTD=0x00;						// Ʈ  reg
;      71 	DDRD=0x00;                                              // Ʈ  reg(0Է,1)
;      72 
;      73 // Timer/Counter0 
;      74 	TCCR0=0x00;
	CALL SUBOPT_0x1
;      75 	TCNT0=0x00;
;      76 	OCR0=0x00;
;      77 
;      78 // Timer/Counter1 
;      79 	TCCR1A=0x00;
	CALL SUBOPT_0x2
;      80 	TCCR1B=0x00;
;      81 	TCNT1H=0x00;
;      82 	TCNT1L=0x00;
;      83 	OCR1AH=0x00;
;      84 	OCR1AL=0x00;
;      85 	OCR1BH=0x00;
;      86 	OCR1BL=0x00;
;      87 
;      88 // Timer/Counter2 
;      89 	ASSR=0x00;
	CALL SUBOPT_0x3
;      90 	TCCR2=0x00;
;      91 	TCNT2=0x00;
;      92 	OCR2=0x00;
;      93 
;      94 // External Interrupt(s) 
;      95 // INT0: Off
;      96 // INT1: Off
;      97 	MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
;      98 	MCUCSR=0x00;
	OUT  0x34,R30
;      99 
;     100 // Timer(s)/Counter(s) Interrupt(s) 
;     101 	TIMSK=0x00;
	OUT  0x39,R30
;     102 
;     103 //  ʱȭ
;     104 // 19200Bps, 8Data, 1 Stop, No Parity
;     105 	UCSRA=0x00;
	OUT  0xB,R30
;     106 	UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     107 	UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     108 	UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     109 	UBRRL=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
;     110 
;     111 // Analog Comparator 
;     112 	ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     113 	SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     114 
;     115 // Global enable interrupts
;     116 #asm("sei")
	sei
;     117 }
	RET
;     118 
;     119 // ================================  ͷƮ =============================
;     120 // [μ] void
;     121 // ----------------------------------------------------------------------------
;     122 #pragma savereg-
;     123 interrupt [USART_RXC] void uart_rx_isr(void)
;     124 {
_uart_rx_isr:
;     125 char status,data;
;     126 #asm
;     127 	push r26
	push r26
;     128 	push r27
	push r27
;     129 	push r30
	push r30
;     130 	push r31
	push r31
;     131 	in   r26,sreg
	in   r26,sreg
;     132 	push r26
	push r26
;     133 #endasm
;     134 
;     135 	status=UCSRA;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
;     136 	data=UDR;
	IN   R16,12
;     137 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;     138 		com1_rx_data = data;
	MOV  R5,R16
;     139 		com1_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     140 	}
;     141 
;     142 #asm
_0x3:
;     143 	pop  r26
	pop  r26
;     144 	out  sreg,r26
	out  sreg,r26
;     145 	pop  r31
	pop  r31
;     146 	pop  r30
	pop  r30
;     147 	pop  r27
	pop  r27
;     148 	pop  r26
	pop  r26
;     149 #endasm
;     150 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     151 #pragma savereg+
;     152 
;     153 // ========================== TIMER0 overflow ͷƮ ========================
;     154 // [μ] void
;     155 // [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
;     156 // ----------------------------------------------------------------------------
;     157 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     158 {
_timer0_ovf_isr:
	CALL SUBOPT_0x4
;     159 	TCNT0 = 99;						// 255-156 = 100
	LDI  R30,LOW(99)
	OUT  0x32,R30
;     160 	timer0_cnt++;						// Ÿ̸0 ī
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
;     161 }
	CALL SUBOPT_0x5
	RETI
;     162 
;     163 // ========================== TIMER1 overflow ͷƮ ========================
;     164 // [μ] void
;     165 // []] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
;     166 // ----------------------------------------------------------------------------
;     167 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     168 {
_timer1_ovf_isr:
	CALL SUBOPT_0x4
;     169 	TCNT1 = 63035;						// 65535 - 2500 = 63035
	LDI  R30,LOW(63035)
	LDI  R31,HIGH(63035)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;     170 	timer1_cnt++;						// Ÿ̸1 ī
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
;     171 }
	CALL SUBOPT_0x5
	RETI
;     172 
;     173 // ========================== TIMER2 overflow ͷƮ ========================
;     174 // [μ] void
;     175 // [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
;     176 // ----------------------------------------------------------------------------
;     177 interrupt [TIM2_OVF] void timer2_ovf_isr(void)
;     178 {
_timer2_ovf_isr:
	CALL SUBOPT_0x4
;     179 	TCNT2 = 99;						// 255-156 = 100
	LDI  R30,LOW(99)
	OUT  0x24,R30
;     180 	timer2_cnt++;						// Ÿ̸2 ī
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
;     181 }
	CALL SUBOPT_0x5
	RETI
;     182 
;     183 // ========================== ܺ INT0 ͷƮ ==============================
;     184 // [μ] void
;     185 // ----------------------------------------------------------------------------
;     186 interrupt [EXT_INT0] void ext_int0_isr(void)
;     187 {
_ext_int0_isr:
	CALL SUBOPT_0x6
;     188 	exint0_flg = 1;						// EXINT0 ÷ ON
	MOVW R12,R30
;     189 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     190 
;     191 // ========================== ܺ INT1 ͷƮ ==============================
;     192 // [μ] void
;     193 // ----------------------------------------------------------------------------
;     194 interrupt [EXT_INT1] void ext_int1_isr(void)
;     195 {
_ext_int1_isr:
	CALL SUBOPT_0x6
;     196 	exint1_flg = 1;						// EXINT1 ÷ ON
	STS  _exint1_flg,R30
	STS  _exint1_flg+1,R31
;     197 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     198 
;     199 // ========================== ܺ INT2 ͷƮ ==============================
;     200 // [μ] void
;     201 // ----------------------------------------------------------------------------
;     202 interrupt [EXT_INT2] void ext_int2_isr(void)
;     203 {
_ext_int2_isr:
	CALL SUBOPT_0x6
;     204 	exint2_flg = 1;						// EXINT2 ÷ ON
	STS  _exint2_flg,R30
	STS  _exint2_flg+1,R31
;     205 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     206 
;     207 // =============================== ADC ͷƮ ===============================
;     208 // [μ] void
;     209 // ----------------------------------------------------------------------------
;     210 interrupt [ADC_INT] void adc_isr(void)
;     211 {
_adc_isr:
	ST   -Y,R30
	ST   -Y,R31
;     212 	adc_int_data = ADCW;					// ADC
	IN   R30,0x4
	IN   R31,0x4+1
	STS  _adc_int_data,R30
	STS  _adc_int_data+1,R31
;     213 	adc_int_flg = 1;					// ADC Ϸ ÷ 
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R31
;     214 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     215 
;     216 // Լ 
;     217 void main_menu_disp(void);					//  ޴ ǥ
;     218 void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ
;     219 void timer0_test(void);						// TIMER0 TEST
;     220 void timer1_test(void);						// TIMER1 TEST
;     221 void timer2_test(void);						// TIMER2 TEST
;     222 void exint_test(void);						// EXINT0,1 TEST
;     223 void ad_polling_test(void);					// A/D   TEST
;     224 unsigned int ad_read(unsigned char adc_input);			// A/D  ( )
;     225 void ad_interrupt_test(void);					// A/D ͷƮ  TEST
;     226 void ad_start(unsigned char adc_input);				// AD  (ͷƮ )
;     227 void eeprom_test(void);						// EEPROM TEST
;     228 void EEPROM_write(int addr,unsigned char data);			// EEPROM  
;     229 unsigned char EEPROM_read(int addr);				// EEPROM  
;     230 
;     231 void urx_string(char buff[]);					// Ʈ 
;     232 long atoh(char buff[]);						// ASCII TO HEX 
;     233 
;     234 //  
;     235 
;     236 // ===============================  α׷ ==============================
;     237 // [μ]: void
;     238 // ---------------------------------------------------------------------------
;     239 void main(void)
;     240 {
_main:
;     241 	cpu_setup();						// cpuʱȭ
	CALL _cpu_setup
;     242 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     243 	while(1){						// Place your code here
_0x4:
;     244 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x7
;     245 			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
	LDI  R30,LOW(49)
	CP   R30,R5
	BRNE _0x8
	RCALL _cpu_ioport_output
;     246 			else if(com1_rx_data == '2') timer0_test(); // TIMER0 TEST
	RJMP _0x9
_0x8:
	LDI  R30,LOW(50)
	CP   R30,R5
	BRNE _0xA
	RCALL _timer0_test
;     247 			else if(com1_rx_data == '3') timer1_test(); // TIMER1 TEST
	RJMP _0xB
_0xA:
	LDI  R30,LOW(51)
	CP   R30,R5
	BRNE _0xC
	RCALL _timer1_test
;     248 			else if(com1_rx_data == '4') timer2_test(); // TIMER2 TEST
	RJMP _0xD
_0xC:
	LDI  R30,LOW(52)
	CP   R30,R5
	BRNE _0xE
	RCALL _timer2_test
;     249 			else if(com1_rx_data == '5') exint_test();  // EXINT0,1 TEST
	RJMP _0xF
_0xE:
	LDI  R30,LOW(53)
	CP   R30,R5
	BRNE _0x10
	RCALL _exint_test
;     250 			else if(com1_rx_data == '6') ad_polling_test();// A/D POLLING TEST
	RJMP _0x11
_0x10:
	LDI  R30,LOW(54)
	CP   R30,R5
	BRNE _0x12
	RCALL _ad_polling_test
;     251 			else if(com1_rx_data == '7') ad_interrupt_test(); // A/D POLLING TEST
	RJMP _0x13
_0x12:
	LDI  R30,LOW(55)
	CP   R30,R5
	BRNE _0x14
	RCALL _ad_interrupt_test
;     252 			else if(com1_rx_data == '8') eeprom_test(); // EEPROM TEST
	RJMP _0x15
_0x14:
	LDI  R30,LOW(56)
	CP   R30,R5
	BRNE _0x16
	RCALL _eeprom_test
;     253 			else putchar(com1_rx_data);
	RJMP _0x17
_0x16:
	ST   -Y,R5
	CALL _putchar
;     254 			com1_rx_eflg = 0;
_0x17:
_0x15:
_0x13:
_0x11:
_0xF:
_0xD:
_0xB:
_0x9:
	CLR  R4
;     255 		}
;     256 	}
_0x7:
	RJMP _0x4
;     257 }
_0x18:
	RJMP _0x18
;     258 
;     259 // =====================================  ޴ ǥ =======================
;     260 // [μ]: void
;     261 // ---------------------------------------------------------------------------
;     262 void main_menu_disp(void)
;     263 {
_main_menu_disp:
;     264 	printf("\r\n");
	CALL SUBOPT_0x7
;     265 	printf("=================== MAIN MENU ==================\r\n");
	__POINTW1FN _0,3
	CALL SUBOPT_0x8
;     266 	printf("- 1  : CPU I/O PORT TEST                        \r\n");
	__POINTW1FN _0,54
	CALL SUBOPT_0x8
;     267 	printf("- 2  : TIMER0 TEST                              \r\n");
	__POINTW1FN _0,105
	CALL SUBOPT_0x8
;     268 	printf("- 3  : TIMER1 TEST                              \r\n");
	__POINTW1FN _0,156
	CALL SUBOPT_0x8
;     269 	printf("- 4  : TIMER2 TEST                              \r\n");
	__POINTW1FN _0,207
	CALL SUBOPT_0x8
;     270 	printf("- 5  : EXINT0,1,2 TEST                          \r\n");
	__POINTW1FN _0,258
	CALL SUBOPT_0x8
;     271 	printf("- 6  : A/D POLLING   TEST                       \r\n");
	__POINTW1FN _0,309
	CALL SUBOPT_0x8
;     272 	printf("- 7  : A/D INTERRUPT TEST                       \r\n");
	__POINTW1FN _0,360
	CALL SUBOPT_0x8
;     273 	printf("- 8  : EEPROM TEST                              \r\n");
	__POINTW1FN _0,411
	CALL SUBOPT_0x8
;     274 	printf("----------------- CPUPLAZA ---------------------\r\n");
	__POINTW1FN _0,462
	CALL SUBOPT_0x8
;     275 }
	RET
;     276 
;     277 // ============================== CPU_IO TEST =================================
;     278 // [μ]: void
;     279 // ----------------------------------------------------------------------------
;     280 void cpu_ioport_output(void)
;     281 {
_cpu_ioport_output:
;     282 int out_cnt,exit_flg = 0;
;     283 
;     284 	printf("================ CPU I/O PORT TEST ==============\r\n");
	CALL SUBOPT_0x9
;	out_cnt -> R16,R17
;	exit_flg -> R18,R19
	__POINTW1FN _0,513
	CALL SUBOPT_0x8
;     285 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xA
;     286 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xB
;     287 // CPU PORT   
;     288 // PORTA[0..7] : OUT
;     289 	PORTA=0xff;						// Ʈ  reg
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     290 	DDRA=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x1A,R30
;     291 // CPU PORT   
;     292 // PORTB[0..7] : OUT
;     293 	PORTB=0xff;						// Ʈ  reg
	OUT  0x18,R30
;     294 	DDRB=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x17,R30
;     295 // PORTC[0..5] : OUT
;     296 	PORTC=0xff;						// Ʈ  reg
	OUT  0x15,R30
;     297 	DDRC=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x14,R30
;     298 // PORTD[2..7] : OUT
;     299 	PORTD=0xfc;						// Ʈ  reg
	LDI  R30,LOW(252)
	OUT  0x12,R30
;     300 	DDRD=0xfc;						// Ʈ  reg(0Է,1)
	OUT  0x11,R30
;     301 
;     302 // LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
;     303 	TCCR0 = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
	CALL SUBOPT_0xC
;     304 	TCNT0 = 99;						// 255-156 = 99
;     305 	OCR0 = 0x00;
;     306 	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
;     307 
;     308 	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
;     309 	out_cnt = 0;
	__GETWRN 16,17,0
;     310 	com1_rx_eflg = 0;
	CLR  R4
;     311 	while(exit_flg == 0){
_0x19:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+3
	JMP _0x1B
;     312 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x1C
;     313 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x1D
	__GETWRN 18,19,1
;     314 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x1E
_0x1D:
	ST   -Y,R5
	CALL _putchar
;     315 			com1_rx_eflg = 0;
_0x1E:
	CLR  R4
;     316 		}
;     317 		if(timer0_cnt >= 50){				// 500ms  
_0x1C:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CP   R6,R30
	CPC  R7,R31
	BRGE PC+3
	JMP _0x1F
;     318 			if(out_cnt >= 0 && out_cnt < 8) PORTA = ~(1 << out_cnt);// PORTA (ش Ʈ 0)
	SUBI R16,0
	SBCI R17,0
	BRLT _0x21
	__CPWRN 16,17,8
	BRLT _0x22
_0x21:
	RJMP _0x20
_0x22:
	MOVW R30,R16
	CALL SUBOPT_0xD
	OUT  0x1B,R30
;     319 			else if(out_cnt >= 8 && out_cnt < 16){	// PORTB 
	RJMP _0x23
_0x20:
	__CPWRN 16,17,8
	BRLT _0x25
	__CPWRN 16,17,16
	BRLT _0x26
_0x25:
	RJMP _0x24
_0x26:
;     320 				if(out_cnt == 8) PORTA = 0xff;	// PORTA CLEAR
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x27
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     321 				PORTB = ~(1 << (out_cnt-8));	// PORTB (ش Ʈ 0)
_0x27:
	MOVW R30,R16
	SBIW R30,8
	CALL SUBOPT_0xD
	OUT  0x18,R30
;     322 			}
;     323 			else if(out_cnt >= 16 && out_cnt < 24){	// PORT C 
	RJMP _0x28
_0x24:
	__CPWRN 16,17,16
	BRLT _0x2A
	__CPWRN 16,17,24
	BRLT _0x2B
_0x2A:
	RJMP _0x29
_0x2B:
;     324 				if(out_cnt == 16) PORTB = 0xff;	// PORTB CLEAR
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x2C
	LDI  R30,LOW(255)
	OUT  0x18,R30
;     325 				PORTC = ~(1 << (out_cnt-16));	// PORTC (ش Ʈ 0)
_0x2C:
	MOVW R30,R16
	SBIW R30,16
	CALL SUBOPT_0xD
	OUT  0x15,R30
;     326 			}
;     327 			else if(out_cnt >= 24 && out_cnt < 30){	// PORTD 
	RJMP _0x2D
_0x29:
	__CPWRN 16,17,24
	BRLT _0x2F
	__CPWRN 16,17,30
	BRLT _0x30
_0x2F:
	RJMP _0x2E
_0x30:
;     328 				if(out_cnt == 24) PORTC = 0xff;	// PORTC CLEAR
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x31
	LDI  R30,LOW(255)
	OUT  0x15,R30
;     329 				PORTD = ~(4 << (out_cnt-24));	// PORTD (ش Ʈ 0)
_0x31:
	MOVW R30,R16
	SBIW R30,24
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	CALL __LSLW12
	COM  R30
	COM  R31
	OUT  0x12,R30
;     330 			}
;     331 			out_cnt++;				//  ġ ī 
_0x2E:
_0x2D:
_0x28:
_0x23:
	__ADDWRN 16,17,1
;     332 			if(out_cnt >= 32) out_cnt = 0;		//  ġ ʰ ˻
	__CPWRN 16,17,32
	BRLT _0x32
	__GETWRN 16,17,0
;     333 			if(out_cnt == 0){			//  ü ʱȭ
_0x32:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x33
;     334 				PORTA = 0xff;
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     335 				PORTB = 0xff;
	OUT  0x18,R30
;     336 				PORTC = 0xff;
	OUT  0x15,R30
;     337 				PORTD = 0xfc;
	LDI  R30,LOW(252)
	OUT  0x12,R30
;     338 			}
;     339 			timer0_cnt = 0;
_0x33:
	CLR  R6
	CLR  R7
;     340 		}
;     341 	}
_0x1F:
	RJMP _0x19
_0x1B:
;     342 
;     343 // Timer/Counter0 
;     344 	TCCR0 = 0x00;
	CALL SUBOPT_0x1
;     345 	TCNT0 = 0;
;     346 	OCR0 = 0x00;
;     347 	TIMSK &= 0xfe;						// TIMER0 ͷƮ 
	IN   R30,0x39
	ANDI R30,0xFE
	OUT  0x39,R30
;     348 
;     349 // CPU PORT ʱⰪ  
;     350 // PORTA
;     351 	PORTA=0x00;						// Ʈ  reg
	CALL SUBOPT_0x0
;     352 	DDRA=0x00;						// Ʈ  reg(0Է,1)
;     353 // PORTB
;     354 	PORTB=0x00;						// Ʈ  reg
;     355 	DDRB=0x00;						// Ʈ  reg(0Է,1)
;     356 // PORTC
;     357 	PORTC=0x00;						// Ʈ  reg
;     358 	DDRC=0x00;						// Ʈ  reg(0Է,1)
;     359 // PORTD
;     360 	PORTD=0x00;						// Ʈ  reg
;     361 	DDRD=0x00;						// Ʈ  reg(0Է,1)
;     362 
;     363 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     364 }
	RJMP _0x133
;     365 
;     366 // ============================== TIMER0 TEST =================================
;     367 // [μ]: void
;     368 // ----------------------------------------------------------------------------
;     369 void timer0_test(void)
;     370 {
_timer0_test:
;     371 int exit_flg = 0;
;     372 
;     373 	printf("=================== TIMER0 TEST =================\r\n");
	CALL SUBOPT_0xE
;	exit_flg -> R16,R17
	__POINTW1FN _0,669
	CALL SUBOPT_0x8
;     374 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xA
;     375 	printf("- interrupt    : TIMER0 Overfow 9.9984ms         \r\n");
	__POINTW1FN _0,721
	CALL SUBOPT_0x8
;     376 	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	__POINTW1FN _0,773
	CALL SUBOPT_0x8
;     377 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xB
;     378 
;     379 // Timer/Counter0 (Overflow)
;     380 	TCCR0 = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
	CALL SUBOPT_0xC
;     381 	TCNT0 = 99;						// 255-156 = 99
;     382 	OCR0 = 0x00;
;     383 	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
;     384 
;     385 	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
;     386 	com1_rx_eflg = 0;
	CLR  R4
;     387 	while(exit_flg == 0){
_0x34:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x36
;     388 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x37
;     389 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x38
	__GETWRN 16,17,1
;     390 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x39
_0x38:
	ST   -Y,R5
	CALL _putchar
;     391 			com1_rx_eflg = 0;
_0x39:
	CLR  R4
;     392 		}
;     393 		if(timer0_cnt >= 100){				// 999.84ms üũ
_0x37:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R6,R30
	CPC  R7,R31
	BRLT _0x3A
;     394 			printf("TIMER0 Overflow Interrupt\r\n");
	__POINTW1FN _0,825
	CALL SUBOPT_0x8
;     395 			timer0_cnt = 0;
	CLR  R6
	CLR  R7
;     396 		}
;     397 	}
_0x3A:
	RJMP _0x34
_0x36:
;     398 
;     399 // Timer/Counter0 
;     400 	TCCR0 = 0x00;
	CALL SUBOPT_0x1
;     401 	TCNT0 = 0;
;     402 	OCR0 = 0x00;
;     403 	TIMSK &= 0xfe;						// TIMER0 ͷƮ 
	IN   R30,0x39
	ANDI R30,0xFE
	OUT  0x39,R30
;     404 
;     405 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     406 }
	RJMP _0x132
;     407 
;     408 // ============================== TIMER1 TEST =================================
;     409 // [μ]: void
;     410 // ----------------------------------------------------------------------------
;     411 void timer1_test(void)
;     412 {
_timer1_test:
;     413 int exit_flg = 0;
;     414 
;     415 	printf("=================== TIMER1 TEST =================\r\n");
	CALL SUBOPT_0xE
;	exit_flg -> R16,R17
	__POINTW1FN _0,853
	CALL SUBOPT_0x8
;     416 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xA
;     417 	printf("- interrupt    : TIMER1 Overfow 10.0ms           \r\n");
	__POINTW1FN _0,905
	CALL SUBOPT_0x8
;     418 	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	__POINTW1FN _0,957
	CALL SUBOPT_0x8
;     419 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xB
;     420 
;     421 // Timer/Counter1 (Overflow)
;     422 	TCCR1A = 0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
;     423 	TCCR1B = 0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	LDI  R30,LOW(3)
	OUT  0x2E,R30
;     424 	TCNT1 = 63035;						// 65535 - 2500 = 63035
	LDI  R30,LOW(63035)
	LDI  R31,HIGH(63035)
	OUT  0x2C+1,R31
	OUT  0x2C,R30
;     425 	OCR1AH = 0x00;
	LDI  R30,LOW(0)
	OUT  0x2B,R30
;     426 	OCR1AL = 0x00;
	OUT  0x2A,R30
;     427 	OCR1BH = 0x00;
	OUT  0x29,R30
;     428 	OCR1BL = 0x00;
	OUT  0x28,R30
;     429 	TIMSK |= 0x04;						// TIMER1 ͷƮ 㰡
	IN   R30,0x39
	ORI  R30,4
	OUT  0x39,R30
;     430 
;     431 	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	CLR  R8
	CLR  R9
;     432 	com1_rx_eflg = 0;
	CLR  R4
;     433 	while(exit_flg == 0){					// COM1  ˻
_0x3B:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x3D
;     434 		if(com1_rx_eflg){
	TST  R4
	BREQ _0x3E
;     435 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x3F
	__GETWRN 16,17,1
;     436 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x40
_0x3F:
	ST   -Y,R5
	CALL _putchar
;     437 			com1_rx_eflg = 0;
_0x40:
	CLR  R4
;     438 		}
;     439 		if(timer1_cnt >= 100){				// 1s üũ
_0x3E:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R8,R30
	CPC  R9,R31
	BRLT _0x41
;     440 			printf("TIMER1 Overflow Interrupt\r\n");
	__POINTW1FN _0,1009
	CALL SUBOPT_0x8
;     441 			timer1_cnt = 0;
	CLR  R8
	CLR  R9
;     442 		}
;     443 	}
_0x41:
	RJMP _0x3B
_0x3D:
;     444 
;     445 // Timer/Counter1 
;     446 	TCCR1A = 0x00;
	CALL SUBOPT_0x2
;     447 	TCCR1B = 0x00;
;     448 	TCNT1H = 0x00;
;     449 	TCNT1L = 0x00;
;     450 	OCR1AH = 0x00;
;     451 	OCR1AL = 0x00;
;     452 	OCR1BH = 0x00;
;     453 	OCR1BL = 0x00;
;     454 	TIMSK &= 0xfb;						// TIMER1 ͷƮ 
	IN   R30,0x39
	ANDI R30,0xFB
	OUT  0x39,R30
;     455 
;     456 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     457 }
	RJMP _0x132
;     458 
;     459 // ============================== TIMER2 TEST =================================
;     460 // [μ]: void
;     461 // ----------------------------------------------------------------------------
;     462 void timer2_test(void)
;     463 {
_timer2_test:
;     464 int exit_flg = 0;
;     465 
;     466 	printf("=================== TIMER2 TEST =================\r\n");
	CALL SUBOPT_0xE
;	exit_flg -> R16,R17
	__POINTW1FN _0,1037
	CALL SUBOPT_0x8
;     467 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xA
;     468 	printf("- interrupt    : TIMER0 Overfow 9.9984ms         \r\n");
	__POINTW1FN _0,721
	CALL SUBOPT_0x8
;     469 	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	__POINTW1FN _0,773
	CALL SUBOPT_0x8
;     470 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xB
;     471 
;     472 // Timer/Counter2 (Overflow)
;     473 	ASSR = 0x00;
	LDI  R30,LOW(0)
	OUT  0x22,R30
;     474 	TCCR2 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	LDI  R30,LOW(7)
	OUT  0x25,R30
;     475 	TCNT2 = 99;						// 255-156 = 99
	LDI  R30,LOW(99)
	OUT  0x24,R30
;     476 	OCR2 = 0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
;     477 	TIMSK |= 0x40;						// TIMER2 ͷƮ 㰡
	IN   R30,0x39
	ORI  R30,0x40
	OUT  0x39,R30
;     478 
;     479 	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	CLR  R10
	CLR  R11
;     480 	com1_rx_eflg = 0;
	CLR  R4
;     481 	while(exit_flg == 0){
_0x42:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x44
;     482 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x45
;     483 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x46
	__GETWRN 16,17,1
;     484 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x47
_0x46:
	ST   -Y,R5
	CALL _putchar
;     485 			com1_rx_eflg = 0;
_0x47:
	CLR  R4
;     486 		}
;     487 		if(timer2_cnt >= 100){				// 999.84ms üũ
_0x45:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R10,R30
	CPC  R11,R31
	BRLT _0x48
;     488 			printf("TIMER2 Overflow Interrupt\r\n");
	__POINTW1FN _0,1089
	CALL SUBOPT_0x8
;     489 			timer2_cnt = 0;
	CLR  R10
	CLR  R11
;     490 		}
;     491 	}
_0x48:
	RJMP _0x42
_0x44:
;     492 
;     493 // Timer/Counter2 
;     494 	ASSR = 0x00;
	CALL SUBOPT_0x3
;     495 	TCCR2 = 0x00;
;     496 	TCNT2 = 0;
;     497 	OCR2 = 0x00;
;     498 	TIMSK &= 0xbf;						// TIMER2 ͷƮ 
	IN   R30,0x39
	ANDI R30,0xBF
	OUT  0x39,R30
;     499 
;     500 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     501 }
	RJMP _0x132
;     502 
;     503 // ============================== EXINT0,1 TEST ===============================
;     504 // [μ]: void
;     505 // ----------------------------------------------------------------------------
;     506 void exint_test(void)
;     507 {
_exint_test:
;     508 int exit_flg = 0;
;     509 
;     510 	printf("=================== EXINT0,1 TEST ===============\r\n");
	CALL SUBOPT_0xE
;	exit_flg -> R16,R17
	__POINTW1FN _0,1117
	CALL SUBOPT_0x8
;     511 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xA
;     512 	printf("- interrupt : INT0 Falling Edge                  \r\n");
	__POINTW1FN _0,1169
	CALL SUBOPT_0x8
;     513 	printf("-             INT1 Falling Edge                  \r\n");
	__POINTW1FN _0,1221
	CALL SUBOPT_0x8
;     514 	printf("-             INT2 Falling Edge                  \r\n");
	__POINTW1FN _0,1273
	CALL SUBOPT_0x8
;     515 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xB
;     516 
;     517 // External Interrupt(s) 
;     518 // INT0 Mode: Falling Edge
;     519 // INT1 Mode: Falling Edge
;     520 // INT2 Mode: Falling Edge
;     521 	GICR|=0xE0;
	IN   R30,0x3B
	ORI  R30,LOW(0xE0)
	OUT  0x3B,R30
;     522 	MCUCR=0x0A;
	LDI  R30,LOW(10)
	OUT  0x35,R30
;     523 	MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
;     524 	GIFR=0xE0;
	LDI  R30,LOW(224)
	OUT  0x3A,R30
;     525 
;     526 	exint0_flg = exint1_flg = exint2_flg = 0;		// EXINT0,1 ͷƮ ÷ Ŭ
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  _exint2_flg,R30
	STS  _exint2_flg+1,R31
	STS  _exint1_flg,R30
	STS  _exint1_flg+1,R31
	MOVW R12,R30
;     527 	com1_rx_eflg = 0;
	CLR  R4
;     528 	while(exit_flg == 0){
_0x49:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x4B
;     529 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BREQ _0x4C
;     530 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x4D
	__GETWRN 16,17,1
;     531 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x4E
_0x4D:
	ST   -Y,R5
	CALL _putchar
;     532 			com1_rx_eflg = 0;
_0x4E:
	CLR  R4
;     533 		}
;     534 		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
_0x4C:
	MOV  R0,R12
	OR   R0,R13
	BREQ _0x4F
;     535 			printf("EXINT0 Interrupt\r\n");
	__POINTW1FN _0,1325
	CALL SUBOPT_0x8
;     536 			exint0_flg = 0;
	CLR  R12
	CLR  R13
;     537 		}
;     538 		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
_0x4F:
	LDS  R30,_exint1_flg
	LDS  R31,_exint1_flg+1
	SBIW R30,0
	BREQ _0x50
;     539 			printf("EXINT1 Interrupt\r\n");
	__POINTW1FN _0,1344
	CALL SUBOPT_0x8
;     540 			exint1_flg = 0;
	LDI  R30,0
	STS  _exint1_flg,R30
	STS  _exint1_flg+1,R30
;     541 		}
;     542 		if(exint2_flg){					// EXINT2 ͷƮ ÷ üũ
_0x50:
	LDS  R30,_exint2_flg
	LDS  R31,_exint2_flg+1
	SBIW R30,0
	BREQ _0x51
;     543 			printf("EXINT2 Interrupt\r\n");
	__POINTW1FN _0,1363
	CALL SUBOPT_0x8
;     544 			exint2_flg = 0;
	LDI  R30,0
	STS  _exint2_flg,R30
	STS  _exint2_flg+1,R30
;     545 		}
;     546 	}
_0x51:
	RJMP _0x49
_0x4B:
;     547 
;     548 // External Interrupt(s) 
;     549 	GICR&=0x1f;
	IN   R30,0x3B
	ANDI R30,LOW(0x1F)
	OUT  0x3B,R30
;     550 	MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
;     551 	MCUCSR=0x00;
	OUT  0x34,R30
;     552 	GIFR=0x00;
	OUT  0x3A,R30
;     553 
;     554 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     555 }
	RJMP _0x132
;     556 
;     557 // ============================== A/D POLLING TEST ============================
;     558 // [μ]: void
;     559 // ----------------------------------------------------------------------------
;     560 void ad_polling_test(void)
;     561 {
_ad_polling_test:
;     562 unsigned datau;
;     563 int exit_flg = 0;
;     564 
;     565 	printf("================= A/D POLLING TEST ==============\r\n");
	CALL SUBOPT_0x9
;	datau -> R16,R17
;	exit_flg -> R18,R19
	__POINTW1FN _0,1382
	CALL SUBOPT_0x8
;     566 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xA
;     567 	printf("- 1  : CH0 READ                                  \r\n");
	__POINTW1FN _0,1434
	CALL SUBOPT_0x8
;     568 	printf("- 2  : CH1 READ                                  \r\n");
	__POINTW1FN _0,1486
	CALL SUBOPT_0x8
;     569 	printf("- 3  : CH2 READ                                  \r\n");
	__POINTW1FN _0,1538
	CALL SUBOPT_0x8
;     570 	printf("- 4  : CH3 READ                                  \r\n");
	__POINTW1FN _0,1590
	CALL SUBOPT_0x8
;     571 	printf("- 5  : CH4 READ                                  \r\n");
	__POINTW1FN _0,1642
	CALL SUBOPT_0x8
;     572 	printf("- 6  : CH5 READ                                  \r\n");
	__POINTW1FN _0,1694
	CALL SUBOPT_0x8
;     573 	printf("- 7  : CH6 READ                                  \r\n");
	__POINTW1FN _0,1746
	CALL SUBOPT_0x8
;     574 	printf("- 8  : CH7 READ                                  \r\n");
	__POINTW1FN _0,1798
	CALL SUBOPT_0x8
;     575 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xB
;     576 
;     577 // ADC initialization 
;     578 	ADMUX = 0x00;						//   AREF
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     579 	ADCSRA = 0x87;						// ADC Enable,ADC Clock 125.000Khz
	LDI  R30,LOW(135)
	CALL SUBOPT_0xF
;     580 	SFIOR &= 0xEF;
;     581 
;     582 	com1_rx_eflg = 0;
	CLR  R4
;     583 	while(exit_flg == 0){
_0x52:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+3
	JMP _0x54
;     584 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BRNE PC+3
	JMP _0x55
;     585 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x56
	__GETWRN 18,19,1
;     586 			else if(com1_rx_data == '1') datau = ad_read(0);// CH0 
	RJMP _0x57
_0x56:
	LDI  R30,LOW(49)
	CP   R30,R5
	BRNE _0x58
	LDI  R30,LOW(0)
	CALL SUBOPT_0x10
;     587 			else if(com1_rx_data == '2') datau = ad_read(1);// CH1 
	RJMP _0x59
_0x58:
	LDI  R30,LOW(50)
	CP   R30,R5
	BRNE _0x5A
	LDI  R30,LOW(1)
	CALL SUBOPT_0x10
;     588 			else if(com1_rx_data == '3') datau = ad_read(2);// CH2 
	RJMP _0x5B
_0x5A:
	LDI  R30,LOW(51)
	CP   R30,R5
	BRNE _0x5C
	LDI  R30,LOW(2)
	CALL SUBOPT_0x10
;     589 			else if(com1_rx_data == '4') datau = ad_read(3);// CH3 
	RJMP _0x5D
_0x5C:
	LDI  R30,LOW(52)
	CP   R30,R5
	BRNE _0x5E
	LDI  R30,LOW(3)
	CALL SUBOPT_0x10
;     590 			else if(com1_rx_data == '5') datau = ad_read(4);// CH4 
	RJMP _0x5F
_0x5E:
	LDI  R30,LOW(53)
	CP   R30,R5
	BRNE _0x60
	LDI  R30,LOW(4)
	CALL SUBOPT_0x10
;     591 			else if(com1_rx_data == '6') datau = ad_read(5);// CH5 
	RJMP _0x61
_0x60:
	LDI  R30,LOW(54)
	CP   R30,R5
	BRNE _0x62
	LDI  R30,LOW(5)
	CALL SUBOPT_0x10
;     592 			else if(com1_rx_data == '7') datau = ad_read(6);// CH6 
	RJMP _0x63
_0x62:
	LDI  R30,LOW(55)
	CP   R30,R5
	BRNE _0x64
	LDI  R30,LOW(6)
	CALL SUBOPT_0x10
;     593 			else if(com1_rx_data == '8') datau = ad_read(7);// CH7 
	RJMP _0x65
_0x64:
	LDI  R30,LOW(56)
	CP   R30,R5
	BRNE _0x66
	LDI  R30,LOW(7)
	CALL SUBOPT_0x10
;     594 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x67
_0x66:
	ST   -Y,R5
	CALL _putchar
;     595 			// A/D  ǥ
;     596 			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("ADC CH%d > %d\r\n",(com1_rx_data&0x0f)-1,datau);
_0x67:
_0x65:
_0x63:
_0x61:
_0x5F:
_0x5D:
_0x5B:
_0x59:
_0x57:
	LDI  R30,LOW(49)
	CP   R5,R30
	BRLO _0x69
	LDI  R30,LOW(56)
	CP   R30,R5
	BRSH _0x6A
_0x69:
	RJMP _0x68
_0x6A:
	__POINTW1FN _0,1850
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R5
	ANDI R30,LOW(0xF)
	SUBI R30,LOW(1)
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOVW R30,R16
	CALL SUBOPT_0x11
;     597 			com1_rx_eflg = 0;
_0x68:
	CLR  R4
;     598 		}
;     599 	}
_0x55:
	RJMP _0x52
_0x54:
;     600 
;     601 // ADC initialization 
;     602 	ADMUX = 0x00;
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     603 	ADCSRA = 0x00;
	CALL SUBOPT_0xF
;     604 	SFIOR &= 0xEF;
;     605 
;     606 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     607 }
_0x133:
	CALL __LOADLOCR4
	ADIW R28,4
	RET
;     608 
;     609 // ============================== A/D POLLING TEST ============================
;     610 // [μ]: unsigned char adc_input
;     611 // ITEM1 : AD CH(0-7)
;     612 // []: A/D 10bit
;     613 // ----------------------------------------------------------------------------
;     614 unsigned int ad_read(unsigned char adc_input)
;     615 {
_ad_read:
;     616 	ADMUX = adc_input;					// ADREF(0) + CH
;	adc_input -> Y+0
	LD   R30,Y
	OUT  0x7,R30
;     617 	ADCSRA |= 0x40;						// AD conversion 
	SBI  0x6,6
;     618 	while((ADCSRA & 0x10) == 0);				//  Ϸ 
_0x6B:
	SBIS 0x6,4
	RJMP _0x6B
;     619 	ADCSRA |= 0x10;						// AD ÷ Ŭ
	SBI  0x6,4
;     620 	return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	RJMP _0x131
;     621 }
;     622 
;     623 // ============================== A/D INTERRUPT TEST ==========================
;     624 // [μ]: void
;     625 // ----------------------------------------------------------------------------
;     626 void ad_interrupt_test(void)
;     627 {
_ad_interrupt_test:
;     628 int exit_flg = 0;
;     629 
;     630 	printf("================ A/D INTEERRUPT TEST ============\r\n");
	CALL SUBOPT_0xE
;	exit_flg -> R16,R17
	__POINTW1FN _0,1866
	CALL SUBOPT_0x8
;     631 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0xA
;     632 	printf("- 1  : CH0 READ                                  \r\n");
	__POINTW1FN _0,1434
	CALL SUBOPT_0x8
;     633 	printf("- 2  : CH1 READ                                  \r\n");
	__POINTW1FN _0,1486
	CALL SUBOPT_0x8
;     634 	printf("- 3  : CH2 READ                                  \r\n");
	__POINTW1FN _0,1538
	CALL SUBOPT_0x8
;     635 	printf("- 4  : CH3 READ                                  \r\n");
	__POINTW1FN _0,1590
	CALL SUBOPT_0x8
;     636 	printf("- 5  : CH4 READ                                  \r\n");
	__POINTW1FN _0,1642
	CALL SUBOPT_0x8
;     637 	printf("- 6  : CH5 READ                                  \r\n");
	__POINTW1FN _0,1694
	CALL SUBOPT_0x8
;     638 	printf("- 7  : CH6 READ                                  \r\n");
	__POINTW1FN _0,1746
	CALL SUBOPT_0x8
;     639 	printf("- 8  : CH7 READ                                  \r\n");
	__POINTW1FN _0,1798
	CALL SUBOPT_0x8
;     640 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xB
;     641 
;     642 // ADC initialization 
;     643 	ADMUX = 0x00;						//   AREF
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     644 	ADCSRA = 0x8f;						// ADC Enable,ADC Clock 125.000Khz,ADC ȯ ͷƮ Ȱȭ
	LDI  R30,LOW(143)
	CALL SUBOPT_0xF
;     645 	SFIOR &= 0xEF;
;     646 
;     647 	adc_int_flg = 0;					// ADCϷ ͷƮ ÷
	LDI  R30,0
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R30
;     648 	adc_int_ch = 0;						// ADC CH = CH0
	LDI  R30,0
	STS  _adc_int_ch,R30
	STS  _adc_int_ch+1,R30
;     649 	com1_rx_eflg = 0;
	CLR  R4
;     650 	while(exit_flg == 0){
_0x6E:
	MOV  R0,R16
	OR   R0,R17
	BREQ PC+3
	JMP _0x70
;     651 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BRNE PC+3
	JMP _0x71
;     652 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x72
	__GETWRN 16,17,1
;     653 			else if(com1_rx_data == '1') ad_start(0);// CH0 
	RJMP _0x73
_0x72:
	LDI  R30,LOW(49)
	CP   R30,R5
	BRNE _0x74
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _ad_start
;     654 			else if(com1_rx_data == '2') ad_start(1);// CH1 
	RJMP _0x75
_0x74:
	LDI  R30,LOW(50)
	CP   R30,R5
	BRNE _0x76
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _ad_start
;     655 			else if(com1_rx_data == '3') ad_start(2);// CH2 
	RJMP _0x77
_0x76:
	LDI  R30,LOW(51)
	CP   R30,R5
	BRNE _0x78
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _ad_start
;     656 			else if(com1_rx_data == '4') ad_start(3);// CH3 
	RJMP _0x79
_0x78:
	LDI  R30,LOW(52)
	CP   R30,R5
	BRNE _0x7A
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _ad_start
;     657 			else if(com1_rx_data == '5') ad_start(4);// CH4 
	RJMP _0x7B
_0x7A:
	LDI  R30,LOW(53)
	CP   R30,R5
	BRNE _0x7C
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _ad_start
;     658 			else if(com1_rx_data == '6') ad_start(5);// CH5 
	RJMP _0x7D
_0x7C:
	LDI  R30,LOW(54)
	CP   R30,R5
	BRNE _0x7E
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _ad_start
;     659 			else if(com1_rx_data == '7') ad_start(6);// CH6 
	RJMP _0x7F
_0x7E:
	LDI  R30,LOW(55)
	CP   R30,R5
	BRNE _0x80
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _ad_start
;     660 			else if(com1_rx_data == '8') ad_start(7);// CH7 
	RJMP _0x81
_0x80:
	LDI  R30,LOW(56)
	CP   R30,R5
	BRNE _0x82
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _ad_start
;     661 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x83
_0x82:
	ST   -Y,R5
	CALL _putchar
;     662 			// A/D  ǥ
;     663 			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("STAT ADC ");
_0x83:
_0x81:
_0x7F:
_0x7D:
_0x7B:
_0x79:
_0x77:
_0x75:
_0x73:
	LDI  R30,LOW(49)
	CP   R5,R30
	BRLO _0x85
	LDI  R30,LOW(56)
	CP   R30,R5
	BRSH _0x86
_0x85:
	RJMP _0x84
_0x86:
	__POINTW1FN _0,1918
	CALL SUBOPT_0x8
;     664 			com1_rx_eflg = 0;
_0x84:
	CLR  R4
;     665 		}
;     666 		if(adc_int_flg){				// ADC  Ϸ ͷƮ ÷
_0x71:
	LDS  R30,_adc_int_flg
	LDS  R31,_adc_int_flg+1
	SBIW R30,0
	BREQ _0x87
;     667 			printf("CH%d > %d\r\n",adc_int_ch,adc_int_data);// ADC CH  ǥ
	__POINTW1FN _0,1854
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_adc_int_ch
	LDS  R31,_adc_int_ch+1
	CALL __CWD1
	CALL __PUTPARD1
	LDS  R30,_adc_int_data
	LDS  R31,_adc_int_data+1
	CALL SUBOPT_0x11
;     668 			adc_int_flg = 0;
	LDI  R30,0
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R30
;     669 		}
;     670 	}
_0x87:
	RJMP _0x6E
_0x70:
;     671 
;     672 // ADC initialization 
;     673 	ADMUX = 0x00;
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     674 	ADCSRA = 0x00;
	CALL SUBOPT_0xF
;     675 	SFIOR &= 0xEF;
;     676 
;     677 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     678 }
_0x132:
	LD   R16,Y+
	LD   R17,Y+
	RET
;     679 
;     680 // ============================== A/D POLLING TEST ============================
;     681 // [μ]: unsigned char adc_input
;     682 // ITEM1 : AD CH(0-7)
;     683 // []: A/D 10bit
;     684 // ----------------------------------------------------------------------------
;     685 void ad_start(unsigned char adc_input)
;     686 {
_ad_start:
;     687 	adc_int_ch = adc_input;					// ADC CH 
;	adc_input -> Y+0
	LD   R30,Y
	LDI  R31,0
	STS  _adc_int_ch,R30
	STS  _adc_int_ch+1,R31
;     688 	ADMUX = adc_input;					// ADREF(0) + CH
	LD   R30,Y
	OUT  0x7,R30
;     689 	ADCSRA |= 0x40;						// AD conversion 
	SBI  0x6,6
;     690 }
_0x131:
	ADIW R28,1
	RET
;     691 
;     692 // ================================ EEPROM TEST ===============================
;     693 // [μ]: void
;     694 // ----------------------------------------------------------------------------
;     695 void eeprom_test(void)
;     696 {
_eeprom_test:
;     697 char ch,buff[100],buff1[30],buff2[30],buff3[30];
;     698 unsigned char uch;
;     699 int i,j,cnt,exit_flg = 0;
;     700 unsigned int saddr,ecnt;
;     701 
;     702 	printf("============== INTERNAL EEPROM TEST =============\r\n");
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,9
	LDI  R24,2
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	LDI  R30,LOW(_0x88*2)
	LDI  R31,HIGH(_0x88*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	ch -> R17
;	buff -> Y+104
;	buff1 -> Y+74
;	buff2 -> Y+44
;	buff3 -> Y+14
;	uch -> R16
;	i -> R18,R19
;	j -> R20,R21
;	cnt -> Y+12
;	exit_flg -> Y+10
;	saddr -> Y+8
;	ecnt -> Y+6
	__POINTW1FN _0,1928
	CALL SUBOPT_0x8
;     703 	printf("- 0 : TOP menu                                   \r\n");
	__POINTW1FN _0,1980
	CALL SUBOPT_0x8
;     704 	printf("  1 : Read  Data(000-3ffh)                       \r\n");
	__POINTW1FN _0,2032
	CALL SUBOPT_0x8
;     705 	printf("  2 : Write Data(000-3ffh)                       \r\n");
	__POINTW1FN _0,2084
	CALL SUBOPT_0x8
;     706 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0xB
;     707 
;     708 	com1_rx_eflg = 0;
	CLR  R4
;     709 	while(exit_flg == 0){
_0x89:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SBIW R30,0
	BREQ PC+3
	JMP _0x8B
;     710 		if(com1_rx_eflg){				// COM1  ˻
	TST  R4
	BRNE PC+3
	JMP _0x8C
;     711 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R5
	BRNE _0x8D
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+10,R30
	STD  Y+10+1,R31
;     712 			else if(com1_rx_data == '1'){
	RJMP _0x8E
_0x8D:
	LDI  R30,LOW(49)
	CP   R30,R5
	BREQ PC+3
	JMP _0x8F
;     713 				i = j = cnt = 0;
	CALL SUBOPT_0x12
;     714 				printf("\r\nREAD(###(Add),***(Count)) > ");
	__POINTW1FN _0,2136
	CALL SUBOPT_0x8
;     715 				urx_string(buff);
	CALL SUBOPT_0x13
;     716 				ch = buff[i++];			//  ˻ ڷ 
;     717 				while(ch != 0x0){
_0x90:
	CPI  R17,0
	BREQ _0x92
;     718 					if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0x94
	CPI  R17,44
	BREQ _0x94
	CPI  R17,32
	BRNE _0x93
_0x94:
;     719 						j = 0;
	CALL SUBOPT_0x14
;     720 						cnt++;
;     721 					}
;     722 					else{
	RJMP _0x96
_0x93:
;     723 						if(cnt == 0){
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0x97
;     724 							buff1[j++] = ch;
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
;     725 							buff1[j] = 0x0;
	RJMP _0x134
;     726 						}
;     727 						else if(cnt == 1){
_0x97:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,1
	BRNE _0x99
;     728 				    			buff2[j++] = ch;
	CALL SUBOPT_0x15
	CALL SUBOPT_0x17
;     729 				    			buff2[j] = 0x0;
_0x134:
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	ST   X,R30
;     730 						}
;     731 			    		}
_0x99:
_0x96:
;     732 				    	ch = buff[i++];
	CALL SUBOPT_0x18
;     733 				}
	RJMP _0x90
_0x92:
;     734 				if(cnt == 1){			// ˻ 
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,1
	BREQ PC+3
	JMP _0x9A
;     735 					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	CALL SUBOPT_0x19
;     736 					ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
;     737 					printf("%04X > ",saddr);// ּ ǥ
	__POINTW1FN _0,2167
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL SUBOPT_0x1A
;     738 					cnt = 0;
	LDI  R30,0
	STD  Y+12,R30
	STD  Y+12+1,R30
;     739 			   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ
	__GETWRN 18,19,0
_0x9C:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R30,R18
	CPC  R31,R19
	BRLO _0x9D
;     740 						uch = EEPROM_read(saddr);//  
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _EEPROM_read
	MOV  R16,R30
;     741 						printf("%02X ",uch);// Ÿ ǥ
	__POINTW1FN _0,2175
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
;     742 						cnt++;
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
;     743 						if(cnt == 16){// 1 ǥ
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,16
	BRNE _0x9E
;     744 							cnt = 0;
	LDI  R30,0
	STD  Y+12,R30
	STD  Y+12+1,R30
;     745 							if(i+1 <= ecnt) printf("\r\n%03X > ",saddr+1);// ּ ǥ
	MOVW R26,R18
	ADIW R26,1
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R30,R26
	CPC  R31,R27
	BRLO _0x9F
	__POINTW1FN _0,2181
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	CALL SUBOPT_0x1A
;     746 						}
_0x9F:
;     747 				    	}
_0x9E:
	CALL SUBOPT_0x1B
	RJMP _0x9C
_0x9D:
;     748 					printf("\r\nRead OK\r\n");
	__POINTW1FN _0,2191
	CALL SUBOPT_0x8
;     749 				}
;     750 			}
_0x9A:
;     751 			else if(com1_rx_data == '2'){
	RJMP _0xA0
_0x8F:
	LDI  R30,LOW(50)
	CP   R30,R5
	BREQ PC+3
	JMP _0xA1
;     752 				i = j = cnt = 0;
	CALL SUBOPT_0x12
;     753 				printf("\r\nWRITE(###(Addr),***(Count),**(Data)) > ");
	__POINTW1FN _0,2203
	CALL SUBOPT_0x8
;     754 				urx_string(buff);
	CALL SUBOPT_0x13
;     755 				ch = buff[i++];			//  ˻ ڷ 
;     756 				while(ch != 0x0){
_0xA2:
	CPI  R17,0
	BREQ _0xA4
;     757 					if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0xA6
	CPI  R17,44
	BREQ _0xA6
	CPI  R17,32
	BRNE _0xA5
_0xA6:
;     758 						j = 0;
	CALL SUBOPT_0x14
;     759 						cnt++;
;     760 					}
;     761 					else{
	RJMP _0xA8
_0xA5:
;     762 						if(cnt == 0){
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0xA9
;     763 							buff1[j++] = ch;
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
;     764 							buff1[j] = 0x0;
	RJMP _0x135
;     765 						}
;     766 						else if(cnt == 1){
_0xA9:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,1
	BRNE _0xAB
;     767 							buff2[j++] = ch;
	CALL SUBOPT_0x15
	CALL SUBOPT_0x17
;     768 							buff2[j] = 0x0;
	RJMP _0x135
;     769 						}
;     770 						else if(cnt == 2){
_0xAB:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,2
	BRNE _0xAD
;     771 							buff3[j++] = ch;
	CALL SUBOPT_0x15
	MOVW R26,R28
	ADIW R26,14
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
;     772 							buff3[j] = 0x0;
	MOVW R26,R28
	ADIW R26,14
_0x135:
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	ST   X,R30
;     773 						}
;     774 					}
_0xAD:
_0xA8:
;     775 					ch = buff[i++];
	CALL SUBOPT_0x18
;     776 				}
	RJMP _0xA2
_0xA4:
;     777 				if(cnt == 2){			// ˻ 
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,2
	BRNE _0xAE
;     778 					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	CALL SUBOPT_0x19
;     779 					ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
;     780 					uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
	MOVW R30,R28
	ADIW R30,14
	ST   -Y,R31
	ST   -Y,R30
	RCALL _atoh
	MOV  R16,R30
;     781 					for(i = 0; i <= ecnt; i++,saddr++) EEPROM_write(saddr,uch);//  
	__GETWRN 18,19,0
_0xB0:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R30,R18
	CPC  R31,R19
	BRLO _0xB1
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R16
	RCALL _EEPROM_write
;     782 					printf("SRAM Data Write OK\r\n");
	CALL SUBOPT_0x1B
	RJMP _0xB0
_0xB1:
	__POINTW1FN _0,2245
	CALL SUBOPT_0x8
;     783 				}
;     784 			}
_0xAE:
;     785 			else putchar(com1_rx_data);		// ݼ
	RJMP _0xB2
_0xA1:
	ST   -Y,R5
	CALL _putchar
;     786 			com1_rx_eflg = 0;
_0xB2:
_0xA0:
_0x8E:
	CLR  R4
;     787 		}
;     788 	}
_0x8C:
	RJMP _0x89
_0x8B:
;     789 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     790 }
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,63
	ADIW R28,63
	ADIW R28,15
	RET
;     791 
;     792 // ============================== EEPROM DATA READ ============================
;     793 // [μ] int addr
;     794 // Item1:  ּ(0 - 511)
;     795 // []  (00 - ff)
;     796 // ----------------------------------------------------------------------------
;     797 unsigned char EEPROM_read(int addr)
;     798 {
_EEPROM_read:
;     799 unsigned char ch;
;     800 
;     801 	while(EECR & 0x02);					//   Ϸñ 
	ST   -Y,R17
;	addr -> Y+1
;	ch -> R17
_0xB3:
	SBIC 0x1C,1
	RJMP _0xB3
;     802 	EEAR = addr;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x1E+1,R31
	OUT  0x1E,R30
;     803 	EECR |= 0x01;
	SBI  0x1C,0
;     804 	ch = EEDR;
	IN   R17,29
;     805 	return(ch);
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x130
;     806 }
;     807 
;     808 // ============================== EEPROM DATA  ============================
;     809 // [μ] int addr,unsigned char data
;     810 // Item1:  ּ(0 - 511)
;     811 // Item2:  (00 - ff)
;     812 // ----------------------------------------------------------------------------
;     813 void EEPROM_write(int addr,unsigned char data)
;     814 {
_EEPROM_write:
;     815 	while(EECR & 0x02);					//   Ϸñ 
;	addr -> Y+1
;	data -> Y+0
_0xB6:
	SBIC 0x1C,1
	RJMP _0xB6
;     816 	EEAR = addr;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x1E+1,R31
	OUT  0x1E,R30
;     817 	EEDR = data;
	LD   R30,Y
	OUT  0x1D,R30
;     818 	EECR |= 0x04;
	SBI  0x1C,2
;     819 	EECR |= 0x02;
	SBI  0x1C,1
;     820 }
_0x130:
	ADIW R28,3
	RET
;     821 
;     822 // ============================ κ ڿ  ====================
;     823 // [μ] char buff[]
;     824 // Item1   Ÿ  (ִ 30)
;     825 // ----------------------------------------------------------------------------
;     826 void urx_string(char buff[])
;     827 {
_urx_string:
;     828 char ch;
;     829 int exit_flg = 0,scnt = 0;
;     830 
;     831 	com1_rx_eflg = 0;
	CALL __SAVELOCR6
;	*buff -> Y+6
;	ch -> R17
;	exit_flg -> R18,R19
;	scnt -> R20,R21
	LDI  R18,0
	LDI  R19,0
	LDI  R20,0
	LDI  R21,0
	CLR  R4
;     832 	buff[0] = 0x0;						//  ũ
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
;     833 	while(exit_flg == 0){
_0xB9:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+3
	JMP _0xBB
;     834 	    while(com1_rx_eflg == 0); com1_rx_eflg = 0;		// 1 
_0xBC:
	TST  R4
	BREQ _0xBC
	CLR  R4
;     835 	    ch = com1_rx_data;					//  Ÿ ε
	MOV  R17,R5
;     836 	    ch = toupper(ch);					//  ȯ
	CALL SUBOPT_0x1C
;     837 	    if(ch == 0x08){					// BSŰ м
	CPI  R17,8
	BRNE _0xBF
;     838 			if(scnt == 0) putchar(0x07);		//  溸 ۽
	MOV  R0,R20
	OR   R0,R21
	BRNE _0xC0
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _putchar
;     839 			else{					// 1ڸ 
	RJMP _0xC1
_0xC0:
;     840 			    putchar(0x08);
	CALL SUBOPT_0x1D
;     841 			    putchar(' ');
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL _putchar
;     842 			    putchar(0x08);
	CALL SUBOPT_0x1D
;     843 			    scnt--;
	__SUBWRN 20,21,1
;     844 			}
_0xC1:
;     845 	    }
;     846 	    else if(ch == 0x0d){
	RJMP _0xC2
_0xBF:
	CPI  R17,13
	BRNE _0xC3
;     847 			exit_flg = 1;				// Ż  ON
	__GETWRN 18,19,1
;     848 			buff[scnt] = 0x0;
	MOVW R30,R20
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;     849 			printf("\r\n");
	CALL SUBOPT_0x7
;     850 	    }
;     851 	    else{
	RJMP _0xC4
_0xC3:
;     852 			buff[scnt++] = ch;			// ڷ 
	CALL SUBOPT_0x15
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
;     853 			putchar(ch);
	ST   -Y,R17
	CALL _putchar
;     854 			if(scnt >= 30){ 			//   ʰ 
	__CPWRN 20,21,30
	BRLT _0xC5
;     855 			    scnt = 29;
	__GETWRN 20,21,29
;     856 			    putchar(0x08);
	CALL SUBOPT_0x1D
;     857 			    putchar(0x07);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _putchar
;     858 			}
;     859 	    }
_0xC5:
_0xC4:
_0xC2:
;     860 	}
	RJMP _0xB9
_0xBB:
;     861 }
	CALL __LOADLOCR6
	ADIW R28,8
	RET
;     862 
;     863 // ========================== ASCII͸ HEXͷ ȯ ==================
;     864 // [μ] unsigned char buff[]
;     865 // Item1  ȯ 
;     866 // [] 0 - 7fffffffh
;     867 // ----------------------------------------------------------------------------
;     868 long atoh(char buff[])
;     869 {
_atoh:
;     870 char ch;
;     871 int i = 0;
;     872 long data = 0;
;     873 
;     874 	ch = buff[i++]; 					//  ε
	SBIW R28,4
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0xC6*2)
	LDI  R31,HIGH(_0xC6*2)
	CALL __INITLOCB
	CALL SUBOPT_0x9
;	*buff -> Y+8
;	ch -> R17
;	i -> R18,R19
;	data -> Y+4
	CALL SUBOPT_0x1E
;     875 	ch = toupper(ch);					// 빮 ȯ
;     876 	while(ch != 0){
_0xC7:
	CPI  R17,0
	BREQ _0xC9
;     877 		ch = ch - '0';              			// 0 - 9 ȯ
	SUBI R17,LOW(48)
;     878 		if(ch > 9) ch = ch - 7;				// A - F ȯ
	CPI  R17,10
	BRLO _0xCA
	SUBI R17,LOW(7)
;     879 		if(ch < 0 || ch > 0x0f) ch = 0;			//  ˻
_0xCA:
	CPI  R17,0
	BRLO _0xCC
	CPI  R17,16
	BRLO _0xCB
_0xCC:
	LDI  R17,LOW(0)
;     880 		else ch = ch & 0x0f;
	RJMP _0xCE
_0xCB:
	ANDI R17,LOW(15)
;     881 		data = data << 4;				// ȯ  
_0xCE:
	__GETD2S 4
	LDI  R30,LOW(4)
	CALL __LSLD12
	__PUTD1S 4
;     882 		data |= ch;
	MOV  R30,R17
	__GETD2S 4
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ORD12
	__PUTD1S 4
;     883 		ch = buff[i++];					//  ε
	CALL SUBOPT_0x1E
;     884 		ch = toupper(ch);				// 빮 ȯ
;     885 	}
	RJMP _0xC7
_0xC9:
;     886 	return(data);
	__GETD1S 4
	CALL __LOADLOCR4
	ADIW R28,10
	RET
;     887 }

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0xCF
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0xD1
	__CPWRN 16,17,2
	BRLO _0xD2
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0xD1:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0xD2:
	RJMP _0xD3
_0xCF:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0xD3:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
_0xD4:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0xD6
	MOV  R30,R17
	CPI  R30,0
	BRNE _0xDA
	CPI  R18,37
	BRNE _0xDB
	LDI  R17,LOW(1)
	RJMP _0xDC
_0xDB:
	RCALL SUBOPT_0x1F
_0xDC:
	RJMP _0xD9
_0xDA:
	CPI  R30,LOW(0x1)
	BRNE _0xDD
	CPI  R18,37
	BRNE _0xDE
	RCALL SUBOPT_0x1F
	RJMP _0x136
_0xDE:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0xDF
	LDI  R16,LOW(1)
	RJMP _0xD9
_0xDF:
	CPI  R18,43
	BRNE _0xE0
	LDI  R20,LOW(43)
	RJMP _0xD9
_0xE0:
	CPI  R18,32
	BRNE _0xE1
	LDI  R20,LOW(32)
	RJMP _0xD9
_0xE1:
	RJMP _0xE2
_0xDD:
	CPI  R30,LOW(0x2)
	BRNE _0xE3
_0xE2:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0xE4
	ORI  R16,LOW(128)
	RJMP _0xD9
_0xE4:
	RJMP _0xE5
_0xE3:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0xD9
_0xE5:
	CPI  R18,48
	BRLO _0xE8
	CPI  R18,58
	BRLO _0xE9
_0xE8:
	RJMP _0xE7
_0xE9:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0xD9
_0xE7:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0xED
	RCALL SUBOPT_0x20
	LD   R30,X
	RCALL SUBOPT_0x21
	RJMP _0xEE
_0xED:
	CPI  R30,LOW(0x73)
	BRNE _0xF0
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x22
	CALL _strlen
	MOV  R17,R30
	RJMP _0xF1
_0xF0:
	CPI  R30,LOW(0x70)
	BRNE _0xF3
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x22
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0xF1:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0xF4
_0xF3:
	CPI  R30,LOW(0x64)
	BREQ _0xF7
	CPI  R30,LOW(0x69)
	BRNE _0xF8
_0xF7:
	ORI  R16,LOW(4)
	RJMP _0xF9
_0xF8:
	CPI  R30,LOW(0x75)
	BRNE _0xFA
_0xF9:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0xFB
_0xFA:
	CPI  R30,LOW(0x58)
	BRNE _0xFD
	ORI  R16,LOW(8)
	RJMP _0xFE
_0xFD:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x12F
_0xFE:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0xFB:
	SBRS R16,2
	RJMP _0x100
	RCALL SUBOPT_0x20
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x101
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x101:
	CPI  R20,0
	BREQ _0x102
	SUBI R17,-LOW(1)
	RJMP _0x103
_0x102:
	ANDI R16,LOW(251)
_0x103:
	RJMP _0x104
_0x100:
	RCALL SUBOPT_0x20
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x104:
_0xF4:
	SBRC R16,0
	RJMP _0x105
_0x106:
	CP   R17,R21
	BRSH _0x108
	SBRS R16,7
	RJMP _0x109
	SBRS R16,2
	RJMP _0x10A
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x10B
_0x10A:
	LDI  R18,LOW(48)
_0x10B:
	RJMP _0x10C
_0x109:
	LDI  R18,LOW(32)
_0x10C:
	RCALL SUBOPT_0x1F
	SUBI R21,LOW(1)
	RJMP _0x106
_0x108:
_0x105:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x10D
_0x10E:
	CPI  R19,0
	BREQ _0x110
	SBRS R16,3
	RJMP _0x111
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x137
_0x111:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x137:
	ST   -Y,R30
	RCALL SUBOPT_0x23
	CPI  R21,0
	BREQ _0x113
	SUBI R21,LOW(1)
_0x113:
	SUBI R19,LOW(1)
	RJMP _0x10E
_0x110:
	RJMP _0x114
_0x10D:
_0x116:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x118:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x11A
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x118
_0x11A:
	CPI  R18,58
	BRLO _0x11B
	SBRS R16,3
	RJMP _0x11C
	SUBI R18,-LOW(7)
	RJMP _0x11D
_0x11C:
	SUBI R18,-LOW(39)
_0x11D:
_0x11B:
	SBRC R16,4
	RJMP _0x11F
	CPI  R18,49
	BRSH _0x121
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x120
_0x121:
	RJMP _0x138
_0x120:
	CP   R21,R19
	BRLO _0x125
	SBRS R16,0
	RJMP _0x126
_0x125:
	RJMP _0x124
_0x126:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x127
	LDI  R18,LOW(48)
_0x138:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x128
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x23
	CPI  R21,0
	BREQ _0x129
	SUBI R21,LOW(1)
_0x129:
_0x128:
_0x127:
_0x11F:
	RCALL SUBOPT_0x1F
	CPI  R21,0
	BREQ _0x12A
	SUBI R21,LOW(1)
_0x12A:
_0x124:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x117
	RJMP _0x116
_0x117:
_0x114:
	SBRS R16,0
	RJMP _0x12B
_0x12C:
	CPI  R21,0
	BREQ _0x12E
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x21
	RJMP _0x12C
_0x12E:
_0x12B:
_0x12F:
_0xEE:
_0x136:
	LDI  R17,LOW(0)
_0xD9:
	RJMP _0xD4
_0xD6:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G2
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	OUT  0x1A,R30
	OUT  0x18,R30
	OUT  0x17,R30
	OUT  0x15,R30
	OUT  0x14,R30
	OUT  0x12,R30
	OUT  0x11,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	OUT  0x33,R30
	OUT  0x32,R30
	OUT  0x3C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	OUT  0x2F,R30
	OUT  0x2E,R30
	OUT  0x2D,R30
	OUT  0x2C,R30
	OUT  0x2B,R30
	OUT  0x2A,R30
	OUT  0x29,R30
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(0)
	OUT  0x22,R30
	OUT  0x25,R30
	OUT  0x24,R30
	OUT  0x23,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	ST   -Y,R30
	ST   -Y,R31
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 72 TIMES, CODE SIZE REDUCTION:281 WORDS
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	CALL __SAVELOCR4
	LDI  R18,0
	LDI  R19,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xA:
	__POINTW1FN _0,565
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xB:
	__POINTW1FN _0,617
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(5)
	OUT  0x33,R30
	LDI  R30,LOW(99)
	OUT  0x32,R30
	LDI  R30,LOW(0)
	OUT  0x3C,R30
	IN   R30,0x39
	ORI  R30,1
	OUT  0x39,R30
	CLR  R6
	CLR  R7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	CALL __LSLW12
	COM  R30
	COM  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE:
	ST   -Y,R17
	ST   -Y,R16
	LDI  R16,0
	LDI  R17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xF:
	OUT  0x6,R30
	IN   R30,0x30
	ANDI R30,0xEF
	OUT  0x30,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x10:
	ST   -Y,R30
	CALL _ad_read
	MOVW R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	RCALL _printf
	ADIW R28,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STD  Y+12,R30
	STD  Y+12+1,R31
	MOVW R20,R30
	MOVW R18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x13:
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	ST   -Y,R31
	ST   -Y,R30
	CALL _urx_string
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(104))
	SBCI R27,HIGH(-(104))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x14:
	__GETWRN 20,21,0
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x15:
	MOVW R30,R20
	__ADDWRN 20,21,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x16:
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x17:
	MOVW R26,R28
	ADIW R26,44
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	MOVW R26,R28
	ADIW R26,44
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x18:
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(104))
	SBCI R27,HIGH(-(104))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x19:
	MOVW R30,R28
	SUBI R30,LOW(-(74))
	SBCI R31,HIGH(-(74))
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoh
	STD  Y+8,R30
	STD  Y+8+1,R31
	MOVW R30,R28
	ADIW R30,44
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoh
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1B:
	__ADDWRN 18,19,1
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	ST   -Y,R17
	CALL _toupper
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	LDI  R30,LOW(8)
	ST   -Y,R30
	JMP  _putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1E:
	MOVW R30,R18
	__ADDWRN 18,19,1
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RJMP SUBOPT_0x1C

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x1F:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x20:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x21:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x22:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x23:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_toupper:
	ld   r30,y+
	cpi  r30,'a'
	brlo __toupper0
	cpi  r30,'z'+1
	brcc __toupper0
	subi r30,32
__toupper0:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ORD12:
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
